run_on_match = "continue"
run_on_dont_match = "" 


def doLockStep ():
	global run_on_match
	global run_on_dont_match
	inferiors = dict()
	for inf in gdb.inferiors():
	  if inf.num > 1:
	    inferiors[inf.num] = inf

	print(inferiors)
	thr1 = inferiors[2].threads()[0]
	thr2 = inferiors[3].threads()[0]
	while thr1.is_running() == True or thr2.is_running() == True:
	  continue
	
	x1 = gdb.parse_and_eval("$x1")
	x2 = gdb.parse_and_eval("$x2")
	if x1 == x2:
	  gdb.execute("inferior 2")
	  gdb.execute(run_on_match) 
	  gdb.execute("inferior 3")
	  gdb.execute(run_on_match)
	  return 1
	else:
	  gdb.execute("inferior 2")
	  gdb.execute(run_on_dont_match)
	  gdb.execute("inferior 3")
	  gdb.execute(run_on_dont_match)
	  return 0


class Lockstep (gdb.Command):
	"""runs gdb continue in 2 inferiors until $x1 != $x2."""
     
	def __init__ (self):
	   super (Lockstep, self).__init__ ("lockstep", gdb.COMMAND_OBSCURE)
     
	def invoke (self, arg, from_tty):
	   while doLockStep() == 1:
	     continue

	   return 0
Lockstep ()
